package com.tptj.demo.hg.template.encrypt;

import com.fr.base.io.EncryptIOFileProxy;
import com.fr.base.io.IOFile;
import com.fr.file.FILE;
import com.fr.invoke.Reflect;
import com.fr.log.FineLoggerFactory;
import com.tptj.demo.hg.template.encrypt.ui.DecodeDialog;
import com.tptj.demo.hg.template.encrypt.ui.SpEncryptAttrMark;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/9/12
 **/
public class BaseInterceptor {
    /**
     * 在打开模板前对加密的模板插入输入密码的弹窗
     * @param file
     */
    public static void intercept4Edit(FILE file){
        try {
            file.asInputStream();
            if( !DemoEncryptor.hasSecret() ){
                return;
            }
            String secret = DemoEncryptor.getSecret();
            secret = new DecodeDialog(file,secret).getSecret();
            DemoEncryptor.setSecret(secret);
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e,e.getMessage());
        }
    }

    /**
     * 在保存模板前获取配置的模板密钥，以便加密接口进行加密
     * @param origin
     */
    public static void intercept4Save( EncryptIOFileProxy origin ){
        IOFile report = Reflect.on(origin).get("file");
        SpEncryptAttrMark mark = report.getAttrMark(SpEncryptAttrMark.XML_TAG);
        if( null != mark ){
            DemoEncryptor.setSecret(mark.getSecret());
        }
    }
}
