package com.tptj.demo.hg.template.encrypt.ui;

import com.fr.json.JSONException;
import com.fr.json.JSONObject;
import com.fr.stable.StringUtils;
import com.fr.stable.fun.impl.AbstractIOFileAttrMark;
import com.fr.stable.xml.XMLPrintWriter;
import com.fr.stable.xml.XMLableReader;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/9/12
 **/
public class SpEncryptAttrMark extends AbstractIOFileAttrMark {
    public final static String XML_TAG = "SpEncryptAttrMark";

    private String secret;

    public String getSecret() {
        return secret;
    }

    public void setSecret(String secret) {
        this.secret = secret;
    }

    @Override
    public String xmlTag() {
        return XML_TAG;
    }

    @Override
    public void readXML(XMLableReader reader) {
        String tag = reader.getTagName();
        if( XML_TAG.equals(tag) ){
            secret = reader.getAttrAsString("secret", StringUtils.EMPTY);
        }
    }

    @Override
    public void writeXML(XMLPrintWriter writer) {
        writer.startTAG(XML_TAG).attr("secret",secret).end();
    }

    @Override
    public SpEncryptAttrMark clone() {
        SpEncryptAttrMark obj = (SpEncryptAttrMark)super.clone();
        obj.secret = secret;
        return obj;
    }

    @Override
    public JSONObject createJSONConfig() throws JSONException {
        JSONObject json = super.createJSONConfig();
        json.put("secret",secret);
        return json;
    }
}
